package com.io.yutian.colorblindwar.game;

import com.io.yutian.colorblindwar.util.BuildSpawner;
import org.bukkit.Material;
import org.bukkit.World;

import java.util.List;

public class GameConfig {

    private BuildSpawner.Direction initialDirection;
    private int chunkWight;
    private int chunkHeight;
    private int ladderLength;
    private int ladderAmount;
    private int platformWidth;
    private int platformLength;
    private int levelAmount;
    private BuildSpawner.SpawnMode spawnMode;
    private List<Material> materials;

    private int completeAmount = 10;
    private int countdownTime = 15;

    public GameConfig(BuildSpawner.Direction initialDirection, int chunkWight, int chunkHeight, int ladderLength, int ladderAmount, int platformWidth, int platformLength, int levelAmount, BuildSpawner.SpawnMode spawnMode, List<Material> materials, int completeAmount, int countdownTime) {
        this.initialDirection = initialDirection;
        this.chunkWight = chunkWight;
        this.chunkHeight = chunkHeight;
        this.ladderLength = ladderLength;
        this.ladderAmount = ladderAmount;
        this.platformWidth = platformWidth;
        this.platformLength = platformLength;
        this.levelAmount = levelAmount;
        this.spawnMode = spawnMode;
        this.materials = materials;
        this.completeAmount = completeAmount;
        this.countdownTime = countdownTime;
    }

    public BuildSpawner.Direction getInitialDirection() {
        return initialDirection;
    }

    public int getChunkWight() {
        return chunkWight;
    }

    public int getChunkHeight() {
        return chunkHeight;
    }

    public int getLadderLength() {
        return ladderLength;
    }

    public int getLadderAmount() {
        return ladderAmount;
    }

    public int getPlatformWidth() {
        return platformWidth;
    }

    public int getPlatformLength() {
        return platformLength;
    }

    public int getLevelAmount() {
        return levelAmount;
    }

    public BuildSpawner.SpawnMode getSpawnMode() {
        return spawnMode;
    }

    public List<Material> getMaterials() {
        return materials;
    }

    public int getCompleteAmount() {
        return completeAmount;
    }

    public int getCountdownTime() {
        return countdownTime;
    }

    public BuildSpawner getSpawner(World world, Point point) {
        return new BuildSpawner(world, initialDirection, point.getBlockX(), point.getBlockY() - 1, point.getBlockZ(), chunkWight, chunkHeight, ladderLength, ladderAmount, platformWidth, platformLength, levelAmount, spawnMode, materials);
    }
}
