package com.io.yutian.colorblindwar.listener;

import com.io.yutian.colorblindwar.ColorblindWar;
import com.io.yutian.colorblindwar.game.Game;
import org.bukkit.entity.Entity;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.block.*;
import org.bukkit.event.entity.EntityDamageEvent;
import org.bukkit.event.entity.EntityExplodeEvent;
import org.bukkit.event.inventory.InventoryClickEvent;
import org.bukkit.event.player.PlayerDropItemEvent;
import org.bukkit.event.player.PlayerQuitEvent;
import org.bukkit.event.player.PlayerRespawnEvent;
import org.bukkit.event.weather.WeatherChangeEvent;

public class PlayerListener implements Listener {

    @EventHandler
    public void onPlayerRespawn(PlayerRespawnEvent event) {
        if (ColorblindWar.getGame().isStarted()) {
            Game game = ColorblindWar.getGame();
            event.setRespawnLocation(game.getSpawnPoint().toLocation(game.getWorld()));
        }
    }

    @EventHandler
    public void onPlayerDamage(EntityDamageEvent event) {
        Entity entity = event.getEntity();
        Game game = ColorblindWar.getGame();
        if (entity instanceof Player player) {
            if (game.isStarted()) {
                EntityDamageEvent.DamageCause damageCause = event.getCause();
                if (damageCause == EntityDamageEvent.DamageCause.VOID) {
                    entity.teleport(game.getSpawnPoint().toLocation(game.getWorld()));
                    event.setCancelled(true);
                }
            }
        }
    }

    @EventHandler
    public void onPlayerQuit(PlayerQuitEvent event) {
        if (ColorblindWar.getGame().isStarted()) {
            ColorblindWar.getGame().stop(false);
        }
    }

    @EventHandler
    public void onPlayerDropItem(PlayerDropItemEvent event) {
        if (ColorblindWar.getGame().isStarted()) {
            event.setCancelled(true);
        }
    }

    @EventHandler
    public void onInventoryClick(InventoryClickEvent event) {
        if (ColorblindWar.getGame().isStarted()) {
            event.setCancelled(true);
        }
    }

    @EventHandler
    public void onBlockBreak(BlockBreakEvent event) {
        if (ColorblindWar.getGame().isStarted()) {
            event.setCancelled(true);
        }
    }

    @EventHandler
    public void onBlockPlace(BlockPlaceEvent event) {
        if (ColorblindWar.getGame().isStarted()) {
            event.setCancelled(true);
        }
    }

    @EventHandler
    public void onEntityExplode(EntityExplodeEvent event) {
        if (ColorblindWar.getGame().isStarted()) {
            event.blockList().clear();
        }
    }

    @EventHandler
    public void onBlockExplode(BlockExplodeEvent event) {
        if (ColorblindWar.getGame().isStarted()) {
            event.blockList().clear();
        }
    }

    @EventHandler
    public void onWeatherChange(WeatherChangeEvent event) {
        if (ColorblindWar.getGame().isStarted()) {
            event.setCancelled(true);
        }
    }

    @EventHandler
    public void onBlockFire(BlockBurnEvent event) {
        if (ColorblindWar.getGame().isStarted()) {
            event.setCancelled(true);
        }
    }

    @EventHandler
    public void onBlockIgnite(BlockIgniteEvent event) {
        if (ColorblindWar.getGame().isStarted()) {
            event.setCancelled(true);
        }
    }

}
